﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Projet_mes.Repositories;

#nullable disable

namespace Projet_mes.Migrations
{
    [DbContext(typeof(MovieDbContext))]
    [Migration("20221210214839_initial")]
    partial class initial
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.11")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder, 1L, 1);

            modelBuilder.Entity("MovieParticipant", b =>
                {
                    b.Property<long>("MoviesRealisatorsId")
                        .HasColumnType("bigint");

                    b.Property<long>("RealisatorsId")
                        .HasColumnType("bigint");

                    b.HasKey("MoviesRealisatorsId", "RealisatorsId");

                    b.HasIndex("RealisatorsId");

                    b.ToTable("realisators", (string)null);
                });

            modelBuilder.Entity("MovieParticipant1", b =>
                {
                    b.Property<long>("ActorsId")
                        .HasColumnType("bigint");

                    b.Property<long>("MoviesActorsId")
                        .HasColumnType("bigint");

                    b.HasKey("ActorsId", "MoviesActorsId");

                    b.HasIndex("MoviesActorsId");

                    b.ToTable("actors", (string)null);
                });

            modelBuilder.Entity("Projet_mes.Models.Genre", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<long>("Id"), 1L, 1);

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.HasKey("Id");

                    b.ToTable("genres");
                });

            modelBuilder.Entity("Projet_mes.Models.Movie", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<long>("Id"), 1L, 1);

                    b.Property<int>("Duration")
                        .HasColumnType("int");

                    b.Property<long?>("GenreId")
                        .HasColumnType("bigint");

                    b.Property<string>("IdentVideo")
                        .HasColumnType("nvarchar(max)")
                        .HasColumnName("ident_video");

                    b.Property<string>("MoviePoster")
                        .HasColumnType("nvarchar(max)")
                        .HasColumnName("movie_poster");

                    b.Property<long?>("NationalityId")
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("ReleaseDate")
                        .IsRequired()
                        .HasColumnType("datetime2")
                        .HasColumnName("release_date");

                    b.Property<string>("Summary")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("TitleVf")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)")
                        .HasColumnName("title_vf");

                    b.Property<string>("TitleVo")
                        .HasColumnType("nvarchar(max)")
                        .HasColumnName("title_vo");

                    b.HasKey("Id");

                    b.HasIndex("GenreId");

                    b.HasIndex("NationalityId");

                    b.ToTable("movies");
                });

            modelBuilder.Entity("Projet_mes.Models.Nation", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<long>("Id"), 1L, 1);

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.HasKey("Id");

                    b.ToTable("nations");
                });

            modelBuilder.Entity("Projet_mes.Models.Participant", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<long>("Id"), 1L, 1);

                    b.Property<DateTime?>("BirthDate")
                        .IsRequired()
                        .HasColumnType("datetime2");

                    b.Property<DateTime?>("DeathDate")
                        .HasColumnType("datetime2");

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("LastName")
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<long>("NationalityId")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.HasIndex("NationalityId");

                    b.ToTable("participants");
                });

            modelBuilder.Entity("MovieParticipant", b =>
                {
                    b.HasOne("Projet_mes.Models.Movie", null)
                        .WithMany()
                        .HasForeignKey("MoviesRealisatorsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Projet_mes.Models.Participant", null)
                        .WithMany()
                        .HasForeignKey("RealisatorsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("MovieParticipant1", b =>
                {
                    b.HasOne("Projet_mes.Models.Participant", null)
                        .WithMany()
                        .HasForeignKey("ActorsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Projet_mes.Models.Movie", null)
                        .WithMany()
                        .HasForeignKey("MoviesActorsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Projet_mes.Models.Movie", b =>
                {
                    b.HasOne("Projet_mes.Models.Genre", "Genre")
                        .WithMany("Movies")
                        .HasForeignKey("GenreId");

                    b.HasOne("Projet_mes.Models.Nation", "Nationality")
                        .WithMany("Movies")
                        .HasForeignKey("NationalityId");

                    b.Navigation("Genre");

                    b.Navigation("Nationality");
                });

            modelBuilder.Entity("Projet_mes.Models.Participant", b =>
                {
                    b.HasOne("Projet_mes.Models.Nation", "Nationality")
                        .WithMany("Actors")
                        .HasForeignKey("NationalityId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Nationality");
                });

            modelBuilder.Entity("Projet_mes.Models.Genre", b =>
                {
                    b.Navigation("Movies");
                });

            modelBuilder.Entity("Projet_mes.Models.Nation", b =>
                {
                    b.Navigation("Actors");

                    b.Navigation("Movies");
                });
#pragma warning restore 612, 618
        }
    }
}
